/* Db.c generated by valac 0.48.23, the Vala compiler
 * generated from Db.vala, do not modify */

/*
* Copyright (c) 2011-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <config.h>
#include <gtk/gtk.h>

#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	DB_VERIFY_RESULT_OK,
	DB_VERIFY_RESULT_FUTURE_VERSION,
	DB_VERIFY_RESULT_UPGRADE_ERROR,
	DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE
} DbVerifyResult;

#define DB_TYPE_VERIFY_RESULT (db_verify_result_get_type ())

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define PHOTOS_TYPE_APPLICATION (photos_application_get_type ())
#define PHOTOS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTOS_TYPE_APPLICATION, PhotosApplication))
#define PHOTOS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTOS_TYPE_APPLICATION, PhotosApplicationClass))
#define PHOTOS_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTOS_TYPE_APPLICATION))
#define PHOTOS_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTOS_TYPE_APPLICATION))
#define PHOTOS_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTOS_TYPE_APPLICATION, PhotosApplicationClass))

typedef struct _PhotosApplication PhotosApplication;
typedef struct _PhotosApplicationClass PhotosApplicationClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

extern gchar* db_filename;
gchar* db_filename = NULL;

#define DB_IN_MEMORY_NAME ":memory:"
void db_preconfigure (GFile* db_file);
void db_init (GError** error);
void database_table_init (const gchar* filename);
void db_terminate (void);
void database_table_terminate (void);
GType db_verify_result_get_type (void) G_GNUC_CONST;
DbVerifyResult db_verify_database (gchar** app_version,
                                   gint* schema_version);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
GType version_table_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VersionTable, database_table_unref)
VersionTable* version_table_get_instance (void);
gint version_table_get_version (VersionTable* self,
                                gchar** app_version);
#define DATABASE_TABLE_SCHEMA_VERSION 21
#define RESOURCES_APP_VERSION _VERSION
void version_table_set_version (VersionTable* self,
                                gint version,
                                const gchar* app_version,
                                const gchar* user_data);
DbVerifyResult db_upgrade_database (gint input_version);
gboolean database_table_has_column (const gchar* table_name,
                                    const gchar* column_name);
gboolean database_table_add_column (const gchar* table_name,
                                    const gchar* column_name,
                                    const gchar* column_constraints);
GType photos_application_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotosApplication, g_object_unref)
void photos_application_set_raw_thumbs_fix_required (PhotosApplication* self,
                                                     gboolean should_fixup);
void version_table_update_version (VersionTable* self,
                                   gint version,
                                   const gchar* app_version);

void
db_preconfigure (GFile* db_file)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_;
	if (db_file != NULL) {
		gchar* _tmp1_;
		_tmp1_ = g_file_get_path (db_file);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (DB_IN_MEMORY_NAME);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	_tmp3_ = g_strdup (_tmp0_);
	_g_free0 (db_filename);
	db_filename = _tmp3_;
	_g_free0 (_tmp0_);
}

void
db_init (GError** error)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	_tmp0_ = db_filename;
	_vala_assert (_tmp0_ != NULL, "filename != null");
	_tmp1_ = db_filename;
	database_table_init (_tmp1_);
}

void
db_terminate (void)
{
	database_table_terminate ();
}

static GType
db_verify_result_get_type_once (void)
{
	static const GEnumValue values[] = {{DB_VERIFY_RESULT_OK, "DB_VERIFY_RESULT_OK", "ok"}, {DB_VERIFY_RESULT_FUTURE_VERSION, "DB_VERIFY_RESULT_FUTURE_VERSION", "future-version"}, {DB_VERIFY_RESULT_UPGRADE_ERROR, "DB_VERIFY_RESULT_UPGRADE_ERROR", "upgrade-error"}, {DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE, "DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE", "no-upgrade-available"}, {0, NULL, NULL}};
	GType db_verify_result_type_id;
	db_verify_result_type_id = g_enum_register_static ("DbVerifyResult", values);
	return db_verify_result_type_id;
}

GType
db_verify_result_get_type (void)
{
	static volatile gsize db_verify_result_type_id__volatile = 0;
	if (g_once_init_enter (&db_verify_result_type_id__volatile)) {
		GType db_verify_result_type_id;
		db_verify_result_type_id = db_verify_result_get_type_once ();
		g_once_init_leave (&db_verify_result_type_id__volatile, db_verify_result_type_id);
	}
	return db_verify_result_type_id__volatile;
}

DbVerifyResult
db_verify_database (gchar** app_version,
                    gint* schema_version)
{
	gchar* _vala_app_version = NULL;
	gint _vala_schema_version = 0;
	VersionTable* version_table = NULL;
	VersionTable* _tmp0_;
	VersionTable* _tmp1_;
	gchar* _tmp2_ = NULL;
	gint _tmp3_;
	DbVerifyResult result = 0;
	_tmp0_ = version_table_get_instance ();
	version_table = _tmp0_;
	_tmp1_ = version_table;
	_tmp3_ = version_table_get_version (_tmp1_, &_tmp2_);
	_g_free0 (_vala_app_version);
	_vala_app_version = _tmp2_;
	_vala_schema_version = _tmp3_;
	if (_vala_schema_version >= 0) {
		const gchar* _tmp4_;
		_tmp4_ = _vala_app_version;
		g_debug ("Db.vala:53: Database schema version %d created by app version %s", _vala_schema_version, _tmp4_);
	}
	if (_vala_schema_version == -1) {
		VersionTable* _tmp5_;
		gchar* _tmp6_;
		g_debug ("Db.vala:57: Creating database schema version %d for app version %s", DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION);
		_tmp5_ = version_table;
		version_table_set_version (_tmp5_, DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION, NULL);
		_tmp6_ = g_strdup (RESOURCES_APP_VERSION);
		_g_free0 (_vala_app_version);
		_vala_app_version = _tmp6_;
		_vala_schema_version = DATABASE_TABLE_SCHEMA_VERSION;
	} else {
		if (_vala_schema_version > DATABASE_TABLE_SCHEMA_VERSION) {
			result = DB_VERIFY_RESULT_FUTURE_VERSION;
			_database_table_unref0 (version_table);
			if (app_version) {
				*app_version = _vala_app_version;
			} else {
				_g_free0 (_vala_app_version);
			}
			if (schema_version) {
				*schema_version = _vala_schema_version;
			}
			return result;
		} else {
			if (_vala_schema_version < DATABASE_TABLE_SCHEMA_VERSION) {
				DbVerifyResult _result_ = 0;
				_result_ = db_upgrade_database (_vala_schema_version);
				if (_result_ != DB_VERIFY_RESULT_OK) {
					result = _result_;
					_database_table_unref0 (version_table);
					if (app_version) {
						*app_version = _vala_app_version;
					} else {
						_g_free0 (_vala_app_version);
					}
					if (schema_version) {
						*schema_version = _vala_schema_version;
					}
					return result;
				}
			}
		}
	}
	result = DB_VERIFY_RESULT_OK;
	_database_table_unref0 (version_table);
	if (app_version) {
		*app_version = _vala_app_version;
	} else {
		_g_free0 (_vala_app_version);
	}
	if (schema_version) {
		*schema_version = _vala_schema_version;
	}
	return result;
}

DbVerifyResult
db_upgrade_database (gint input_version)
{
	gint version = 0;
	VersionTable* _tmp1_;
	VersionTable* _tmp2_;
	DbVerifyResult result = 0;
	_vala_assert (input_version < DATABASE_TABLE_SCHEMA_VERSION, "input_version < DatabaseTable.SCHEMA_VERSION");
	if (!database_table_has_column ("EventTable", "comment")) {
		g_message ("Db.vala:84: upgrade_database: adding comment column to EventTable");
		if (!database_table_add_column ("EventTable", "comment", "TEXT")) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 18;
	if (input_version < 19) {
		GApplication* _tmp0_;
		_tmp0_ = g_application_get_default ();
		photos_application_set_raw_thumbs_fix_required (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTOS_TYPE_APPLICATION, PhotosApplication), TRUE);
	}
	version = 19;
	version = 20;
	if (!database_table_has_column ("PhotoTable", "enhanced")) {
		g_message ("Db.vala:126: upgrade_database: adding enhanced column to PhotoTable");
		if (!database_table_add_column ("PhotoTable", "enhanced", "INTEGER DEFAULT 0")) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	if (!database_table_has_column ("PhotoTable", "original_transforms")) {
		g_message ("Db.vala:132: upgrade_database: adding original_transforms column to Ph" \
"otoTable");
		if (!database_table_add_column ("PhotoTable", "original_transforms", "TEXT")) {
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
			return result;
		}
	}
	version = 21;
	_vala_assert (version == DATABASE_TABLE_SCHEMA_VERSION, "version == DatabaseTable.SCHEMA_VERSION");
	_tmp1_ = version_table_get_instance ();
	_tmp2_ = _tmp1_;
	version_table_update_version (_tmp2_, version, RESOURCES_APP_VERSION);
	_database_table_unref0 (_tmp2_);
	g_message ("Db.vala:141: Database upgrade to schema version %d successful", version);
	result = DB_VERIFY_RESULT_OK;
	return result;
}

